<template>
	<a-spin :spinning="state.loading" size="large">
        <a-icon slot="indicator" type="loading" spin />
		<div class="row d-flex align-items-center">
			<div class="col-6">
				<h3>
					Новый сотрудник
				</h3>
			</div>
			<div class="col-6 d-flex justify-content-end">
			    <a-button type="primary" icon="arrow-left" @click="$router.push({ name: 'UsersPage' })">Назад</a-button>
			</div>
			<div class="col-12" v-if="right">
				<form>
					<div class="form-group">
						<label>
							Отдел <span class="text-danger">*</span>
							<div class="pt-3">
								<a-radio-group @change="changeDepartment" v-model="add.department" v-for="dep in departments" :key="dep.id">
							    	<a-radio :style="radioStyle" :value="dep.id">{{ dep.name }}</a-radio>
							  	</a-radio-group>
							</div>
						</label>
					</div>
					<div class="form-group">
						<label>
							Логин (Фамилия, нижнее подчеркивание, иницииалы. Латинскими буквами) <span class="text-danger">*</span>
						</label>
						<a-input placeholder="Введите логин нового сотрудника" v-model="add.email" />
					</div>
					<div class="form-group">
						<label>
							Email <span class="text-danger">*</span>
						</label>
						<a-input placeholder="Введите email нового сотрудника" v-model="add.work_email" />
					</div>
					<div class="form-group">
						<label>
							Пароль (Задайте пароль, либо <a href="javascript:void(0)" @click="setDefaultPassword">поставте по умолчанию</a>) <span class="text-danger">*</span>
						</label>
						<a-input placeholder="Введите email нового сотрудника" v-model="add.password" />
					</div>
					<div class="form-group">
						<label>
							Фамилия <span class="text-danger">*</span>
						</label>
						<a-input placeholder="Введите Фамилию нового сотрудника" v-model="add.l_name" />
					</div>
					<div class="form-group">
						<label>
							Имя <span class="text-danger">*</span>
						</label>
						<a-input placeholder="Введите фамилию имя сотрудника" v-model="add.f_name" />
					</div>
					<div class="form-group">
						<label>
							Отчество
						</label>
						<a-input placeholder="Введите отчество нового сотрудника" v-model="add.m_name" />
					</div>
					<div class="form-group">
						<label>
							Мобильный телефон
						</label>
						<a-input placeholder="Введите мобильный телефон нового сотрудника" v-model="add.mob_phone" />
					</div>
					<div class="form-group">
						<label>
							Рабочий телефон
						</label>
						<a-input placeholder="Введите рабочий телефон нового сотрудника" v-model="add.work_phone" />
					</div>
					<div class="form-group">
						<label>
							Должность
						</label>
						<a-input placeholder="Введите должность нового сотрудника" v-model="add.position" />
					</div>
					<div class="form-group">
						<a-button type="primary" @click="prepareData">Отправить</a-button>
					</div>
				</form>
			</div>
			<div v-else>
				<a-alert message="У вас нет прав на эту операцию" type="error" />
			</div>
		</div>
	</a-spin>
</template>

<script type="text/javascript">
	export default {
		data () {
			return {
				radioStyle: {
			        display: 'block',
			        height: '30px',
			        lineHeight: '30px',
			    },
				departments: '',
				right: false,
				state: {
					loading: false
				},
				add: {
					email: '',
					work_email: '',
					password: '',
					f_name: '',
					l_name: '',
					m_name: '',
					mob_phone: '',
					work_phone: '',
					department: ''
				}
			}
		},
		created () {
			this.$http.get(this.$store.state.api.url+'getAllDepartments')
			.then(this.loadDepartmentsSuccess,this.loadDepartmentsError);
			let scopes = JSON.parse(this.$store.state.user.scopes);
			for (var i = scopes.length - 1; i >= 0; i--) {
				if (scopes[i] === '*' || scopes[i] === 'usersRight') {
					this.right = true
				}
			}
		},
		methods: {
			prepareData () {
				if (this.add.department === '') {
					this.$message.error('Выберите отдел');
					return false;
				}
				if (this.add.email === '') {
					this.$message.error('Введите логин нового сотрудника');
					return false;
				}
				if (this.add.work_email === '') {
					this.$message.error('Введите логин нового сотрудника');
					return false;
				}
				if (this.add.password === '') {
					this.$message.error('Введите пароль нового сотрудника');
					return false;
				}
				if (this.add.l_name === '') {
					this.$message.error('Введите фамилию нового сотрудника');
					return false;
				}
				if (this.add.f_name === '') {
					this.$message.error('Введите имя нового сотрудника');
					return false;
				}

				this.addUser(this.add);
			},
			changeDepartment (e) {
				this.add.department = e.target.value;
			},
			loadDepartmentsSuccess (res) {
				this.departments = res.body;
			},
			addUser (data) {
				this.$http.post(this.$store.state.api.url+'addUser', data)
				.then(this.addUserSuccess,this.addUserError);
			},
			addUserSuccess (res) {
				this.$message.success('Сотрудник добавлен!');
				this.$router.push({ name: 'UsersPage' });
			},
			addUserError (err) {
				console.log(err);
				this.$message.error('Во время выполнения операции произошла ошибка. Обратитесь к администратору!');
				return false;
			},
			setDefaultPassword () {
				this.add.password = this.$store.state.password_default;
			}
		}
	} 
</script>